/**
GestoreJava.java

    Questa classe implementa il ServerRmi e si registra al rmiregistry
    rendendosi disponibile al servizio "Stato"
    Le entry di ogni ServerRmi nell'rmiRegistry saranno del tipo:
               name= "//"+hostRmiregistry+"/Stato/hostServeRMI"
    che significano:
          hostRmiregistry  : host in cui un serverRMI si  registrato
          Stato            : servizio offerto dall serverRMI
          hostServeRMI     : host del ServerRMI


    Versine alpha per testare
      java -Djava.rmi.server.codebase=http://hostServerWeb:86/
                    CaricoMacchina.GestoreJava -h hostServerWeb


25/02/2000

    Per fare test faccio un ciclo per creare 5 reference di serveRMI con
    nomi diversi.

    OCCORRE TROVARE IN MODO AUTOMATICO L'IP DELLA MACCHINA

27/02/2000
Gabriele Tinti
*/
package CaricoMacchina;

import java.io.*;
import java.net.*;
import java.rmi.*;
import java.rmi.server.*;


public class GestoreJava extends UnicastRemoteObject
                          implements GestoreJavaRem
{
  private static GestoreNative gestoreNative=null;

  String hostServerWeb = null;

  // Costruttore
  public GestoreJava() throws RemoteException {
          super();
           // Crea un'istanza di GestoreNative
        try{  gestoreNative = new GestoreNative();
        }
        catch (Exception e)
            // Gestione di eventuali problemi legati a un cresh
            // gestoreNAtive
            {System.out.println("Problemi nella creazioen di GestoreNative");
              e.printStackTrace(); System.exit(1);   }
  }
  /////

  //toglie la sua registrazione dall' rmiRegistry
  public void fineSessione()
  {//ADD CODE HERE
  }
  /////


  //  metodi remoti che verrano esportati
  public float getCpu(){if(gestoreNative!=null)return gestoreNative.getCpu();
          else return -1;}
  public long getMem(){if(gestoreNative!=null)return gestoreNative.getMem();
          else return -1;}
  public String toFormatString(){if(gestoreNative!=null)return gestoreNative.toString();
          else return "Problemi nel reperimento informazioni";}
  public Response getState(){
            if(gestoreNative!=null)return gestoreNative.getState();
          else return null;
  }
  /////

  boolean  registratiAlServlet()
  {//Preparazione del messaggio da inviare all'applet
      OptionRequest mess = new OptionRequest();
      mess.typeRequest=0;
      try{
      mess.jHostRMI   = InetAddress.getLocalHost().getHostName();
      }catch(java.net.UnknownHostException ex)
          {
          System.out.println("GestoreJava: host sconosiuta");
          return false;
          }

    //Preparazione indirizzo con cui connettersi al servlet

      String strUrl="http://"+hostServerWeb+"/servlet/CaricoMacchina.MonitorService";

      System.out.println("GestoreJava: Ho costruito l'url: "+strUrl);
    // IL CODICE SOTTOSTANTE INVOCA doPost E APRE DEGLI OBJECTSTREAM
      // apertura connessione
      try{
      URL anUrl = new URL(strUrl);

      URLConnection con = anUrl.openConnection();


      // apre una connessione bidirezionale
      con.setDoInput(true);
      con.setDoOutput(true);
      // disabilita la cache del browser
      con.setUseCaches(false);
      // non esiste un MIME type per gli oggetti, questa riga  indicativa
      con.setRequestProperty("Content-Type","java-internal/" );

      // CREAZIONE DI OUTPUT STREAM
      ObjectOutputStream out = new ObjectOutputStream(con.getOutputStream());
      // scrive l'oggetto sull' output stream e torna lo stream di input
      // Spedire L'oggetto OptionRequest al servlet
      out.writeObject(mess);
      out.flush();
      ObjectInputStream in = new ObjectInputStream(con.getInputStream());
      String risposta = (String)in.readObject();
      //out.close();
      }catch(Exception e)
        {
          System.out.println("GestoreJava: Problemi connessione al ServerWeb");
          return false;
         }
      System.out.println("GestoreJava: Registrazione al serverWeb avvenuta;");
      return true;
}//registrati

  //Parte il serverRMI e si registra all'rmiregistry
  public static void main(String[] args) {
        boolean b_connettitiAlServlet=true;
        String hostServerWeb=null;
        //Attivazione dell'RMISecurity Manager
        if (System.getSecurityManager() == null) {
            System.setSecurityManager(new RMISecurityManager());}
        /////


        // Controllo argomenti
        // devono essere del tipo :
        //  -h nomeServerWeb
        if((args.length==2)&&(args[0].equals("-h"))) {
				    hostServerWeb = args[1];	}
        else
        if(args.length==0)b_connettitiAlServlet=false;
        else
          {System.out.println("Errore argomenti: digitare java CaricoMacchina.GestoreJava -h nomeHostServerWeb");
          System.exit(1);   }

        String name;
        // TEST le righe con ** servono per il test
        boolean ribalta= false;   //** serve per creare dei servizi da scartare per il test
        //Creo  5 gestori identici con nomi diversi per il test

        // nomeLocalhost  l'host dell'rmiregistry
        String nomeLocalHost=null;
        try{
            nomeLocalHost= InetAddress.getLocalHost().getHostName();
            }catch(java.net.UnknownHostException e)
            {
              nomeLocalHost= "LocalHost";
            }
          name = "rmi://"+nomeLocalHost+"/Stato";

        // la sintassi  "//host:port/nomeObj"  port di default  1099,
        // nomeObj nome qc per l'oggetto
        System.out.println(name);
        /////

        GestoreJava gestoreJava;
        // Crea un'istanza di GestoreJava
           try{
            gestoreJava = new GestoreJava();
            gestoreJava.hostServerWeb=hostServerWeb;
            // si registra la serverWeb
            if(b_connettitiAlServlet)
            if(!gestoreJava.registratiAlServlet())
              {
                System.out.println("GestoreJava: Problemi connessione al serverWeb");
                System.exit(1);
              }
            // Registra GestoreJava a rmiregistry
            //Si registra come gestore di oggetti di tipo Compute
            System.out.println("Istanzio correttamente");
            Naming.rebind(name, gestoreJava);
            System.out.println("GestoreJava bound");
            }
            catch (Exception e) {
            //Problemi nella creazione di GesotoreJava
            System.err.println("Problemi nella connessione con rmiRegistry");
            System.err.println("GestoreJava new: \n" + e.getMessage());
            e.printStackTrace();System.exit(1);   }
        /////
        /////
    }// end main
}//end GestoreJava
