/**
GestoreJavaLAN.java
    Questa classe  un server di una LAN per permettere di testare lo Stato  di
    tutte le macchine che si sono registrate a un serverRMILocale.
    Per ogni macchina locale GestoreJavaLAN registra una sua istanza nel
    rmiregistry locale

    Questa classe implementa il ServerRmi e si registra al rmiregistry
    rendendosi disponibile al servizio "Stato"
    Le entry di ogni ServerRmi nell'rmiRegistry saranno del tipo:
               name= "//"+hostRmiregistry+"/Stato/hostServeRMI"
    che significano:
          hostRmiregistry  : host in cui un serverRMI si  registrato
          Stato            : servizio offerto dall serverRMI
          hostServeRMI     : host del ServerRMI

  Crea un processo che tiene monitorato il serverRMILocale
  in caso di nuovi ingressi


    Versine alpha per testare
      java -Djava.rmi.server.codebase=http://hostServerWeb:86/
                    CaricoMacchina.GestoreJava -h hostRmi:port -hl hostRmiLan:port


19/03/2000
Gabriele Tinti
*/

package CaricoMacchina;

import java.net.*;
import java.rmi.*;
import java.rmi.server.*;
import java.lang.reflect.Array;
import java.util.Vector;
import java.io.*;

public class GestoreJavaLAN extends GestoreJava{

  private static GestoreNative gestoreNative=null;

  //macchinaLAN  un reference a una istanza di GestoreJava residente su una LAN
  GestoreJavaRem macchinaLAN;
  //questo  l'host della LAN a cui questa istanza  collegata
  String hostLan=null;
  String nameLocalHost=null;
  String serverList[];

  private static Vector serverRmiList =new Vector();

  // Costruttore
  public GestoreJavaLAN() throws RemoteException {
          super(); }
  /////
/*
  private GestoreJavaRem prelevaRemote()
  {
   try {
            // RICHIEDO il reference del ServerRMI chiamato hostLAN
            macchinaLAN = (GestoreJavaRem) Naming.lookup(hostLan);
            System.out.println("Ho un reference da remoto: "+hostLan);
        //Gestione errori
        } catch (Exception e) {
            System.err.println("GestoreJavaLAN problemi nel reperire oggetti registrati");
            e.printStackTrace();
            macchinaLAN = null;
        }
   return macchinaLAN;
  }
*/

/*  public void init()
  { macchinaLAN=prelevaRemote();}
*/
  //  metodi remoti che verrano esportati
  public float getCpu(){

          if(macchinaLAN!=null)try{return macchinaLAN.getCpu();}
              catch(RemoteException e){System.out.println("Problemi con metodi Remoti");}
          return -1;
          }

  public long getMem(){if(macchinaLAN!=null)try{return macchinaLAN.getMem();}
              catch(RemoteException e){System.out.println("Problemi con metodi Remoti");}
              return -1;}
  public String toFormatString(){if(macchinaLAN!=null)return macchinaLAN.toString();
            return "Problemi nel reperimento informazioni";}
  public Response getState(){
            if(macchinaLAN!=null)try{return macchinaLAN.getState();}
              catch(RemoteException e){System.out.println("Problemi con metodi Remoti");}
            return null;
  }

  /////
  public void startFiglio(){
                Figlio figlio;
                figlio = new Figlio();
                figlio.run();
                }



  //Parte il serverRMI e si registra all'rmiregistry
  public static void main(String[] args) {
        GestoreJava gestoreJava= null;
        String hostRmi  = null;
        String hostRmiLan= null;

        //Attivazione dell'RMISecurity Manager
        if (System.getSecurityManager() == null) {
            System.setSecurityManager(new RMISecurityManager());}
        /////


        // Controllo argomenti
        // devono essere del tipo :
        //  -h nomehostRmiregistry
        String hostServerWeb=null;
        if((args.length==2)&&(args[0].equals("-h"))) {
				    hostServerWeb = args[1];}
        else
          {System.out.println("Errore argomenti: digitare java CaricoMacchina.GestoreJava -h nomeHostserverWeb");
          System.exit(1);   }



        String name,nameLocalHost=null;
        try{
            nameLocalHost= InetAddress.getLocalHost().getHostName();
            }catch(java.net.UnknownHostException e)
            {
              nameLocalHost= "LocalHost";
            }
          name = "rmi://"+nameLocalHost+"/Stato";
        //Istanzia se stesso
        // la sintassi  "//host:port/nomeObj"  port di default  1099,
        // nomeObj nome qc per l'oggetto
        System.out.println(name);
        /////
        // Crea un'istanza di GestoreJava
           try{
            gestoreJava = new GestoreJava();
            gestoreJava.hostServerWeb=hostServerWeb;
            // si registra la serverWeb
            if(!gestoreJava.registratiAlServlet())
              {
                System.out.println("GestoreJava: Problemi connessione al serverWeb");
                System.exit(1);
              }


            // Registra GestoreJava a rmiregistry
            //Si registra come gestore di oggetti di tipo Compute
            System.out.println("Istanzio correttamente");
            Naming.rebind(name, gestoreJava); //istanzia se stesso
            System.out.println("GestoreJava bound");
            }
            catch (Exception e) {
            //Problemi nella creazione di GesotoreJava
            System.err.println("Problemi nella connessione con rmiRegistry");
            System.err.println("GestoreJava new: \n" + e.getMessage());
            e.printStackTrace();System.exit(1);   }


        //Crea un processo che tiene monitorato tutti gli host della lan
        //in caso di nuovi ingressi o problemi
        /////
        /////
        try{
        GestoreJavaLAN gestore= new GestoreJavaLAN();
        gestore.hostServerWeb=hostServerWeb;
        gestore.startFiglio();
        }
        catch(RemoteException e){
                System.out.println("Problemi a fare il run del thread");
                System.exit(1);}

    }// end main

    //Thread tiene aggiornato il monitor
    public class Figlio extends Thread {

     private long time=15000; //tempo di sleep prima di aggiornamento


      public Figlio() {
      }

  //Legge tutti i reference in host rmiRegistryLAN e
  //crea delle istanze di GestoreJavaRem per rmiRegistry e MonitorService
  public void run(){

      GestoreJavaLAN gestoreJavaLAN;
      System.out.println("Run del thread gestore rmiregistry e rmiregistryLan");
      ///////////////////////
      //Prelievo reference da rmiRegistryLAN
        //Creazione SecurityManager
     if (System.getSecurityManager() == null) {
          System.setSecurityManager(new RMISecurityManager());
       }
  /////
      ///////////////////////////////////////////////
      //aggiornamento RMI registry locale
      //////////////////////////////////////////////
      while(true) //ciclo infinito del thread
      {
      BufferedReader fileIn=null;
      try{
       fileIn = new BufferedReader(new FileReader("Hosts.dat"));
      }catch(FileNotFoundException ex){System.out.println("File non trovato.");
                          System.exit(1);
                          }
      String hostLetto=null;
    //Lettura da file deglio host della LAN
        try{
              while((hostLetto=fileIn.readLine())!=null)serverRmiList.add(hostLetto);
              fileIn.close();
        }
          catch(IOException ex)
          { System.out.println("Problemi Lettura file");
            try {this.sleep(time) ;}catch(InterruptedException e){};continue;}


      // Acquisizione di tutti i reference registrati all'rmiregistry

        try {
            System.out.println("Richiesta lista serveRMI al rmiregistry");
            System.out.println("numero ServerRmi registrati nella lista locale: "+serverRmiList.size());
            String rmiUrl = null;;
  /////

      // Ciclo per contattare tutti e soli i serverRmi registrati
      // per il servizio Stato
        GestoreJavaRem macchina =null;
        for(int i=0;i<serverRmiList.size();i++)
        {
        try {
            rmiUrl= "rmi://"+serverRmiList.elementAt(i)+"/Stato";
            // RICHIEDO il reference del ServerRMILAN chiamato serverList[i]
            try{
            System.out.println("Thread Figlio: contatto  "+rmiUrl);
            macchina = (GestoreJavaRem) Naming.lookup(rmiUrl);
            System.out.println("Thread Figlio: "+rmiUrl + " Attivo.") ;
            }catch( NotBoundException ex)
                {
                  System.out.println("Thread Figlio: non disponibile "+rmiUrl);
                  continue;
                }
             catch(java.rmi.UnknownHostException ex)
                {
                  System.out.println("Thread Figlio: non disponibile "+rmiUrl);
                  continue;
                }





            //Si richiede l'esecuzione dei metodi per prelevare lo stato
            //Aggiungere metodi di costruzione tabella o html pag

      //Istanziaziazione di GestoreJavaRem per ogni locale reigstrato
            gestoreJavaLAN = new GestoreJavaLAN();
            gestoreJavaLAN.macchinaLAN = macchina;
            gestoreJavaLAN.hostLan = rmiUrl;
            gestoreJavaLAN.nameLocalHost=nameLocalHost;

      //Registrazione a rmiRegistry
            String name;
            // nome del remoto da registrare al rmiregistry globale
            name = "//"+nameLocalHost+"/Stato/"+serverRmiList.elementAt(i);
           try{
            Naming.rebind(name, gestoreJavaLAN); //istanzia se stesso
            System.out.println("GestoreJavaLAN bound");
            }
            catch (Exception e) {
            //Problemi nella creazione di GesotoreJava
            System.err.println("Problemi nella connessione con rmiRegistry");
            }

         //Gestione errori
        } catch (Exception e) {
            System.err.println("Thread Figlio exception: \n" + e.getMessage());
            e.printStackTrace();
        }
        }/////// end ciclo prelevamento reference
     ///////////////////////
        } catch (Exception e) {
            System.err.println("MonitorService: pb nell'acquisizione dei reference: \n" + e.getMessage());
            System.err.println("MonitorService: riprovo pi tardi");
            e.printStackTrace();
        }
      //Aggiornamento ogni time millisecondi (15 sec)
      try {this.sleep(time) ;}catch(InterruptedException e){};
      serverRmiList.removeAllElements();

      }//end loop infinito
  }//end run
}//end Figlio


}//end GestoreJavaLAN





