/**
  GestoreNative.java

  Questa classe implementa tutti i metodi per accedere allo stato della macchina
  su cui viene eseguita.

  Viene referenziata da GestoreJava.
  I metodi accessibili esternamente sono:
    getCpu();
    getMem();
    toString();  //Da una rappresentazione dello stato della macchina.

25/02/2000 ver.1.0

   Implemento due metodi nativi


   La libreria di riferimento sar
	NativeCpuMem.dll 	-> Win32
	libNativeCpuMem.so	-> SunOs, Linux

16/03/2000
Gabriele Tinti
*/

package CaricoMacchina;

import java.lang.Runtime;
import java.util.Date;
import java.net.InetAddress;

public class GestoreNative {

  // Variabili contenenti lo stato della macchina
  private float	 cpu;
  private long	 memTot;
  private long	 memUsed;
  private long	 memFree;
  ///

  // Caricamento della libreria
  static{System.loadLibrary("nativeCpuMem");}
  ///

  // Costruttore
  public GestoreNative() {
      init();
  }
  ///


  // Metodi nativi
  // Aggiornano le variabili cpu e mem e ne restituiscono il valore
  private native  float getCpuNative();
  private native  long  getMemNative();

  //JAVA dispone del metodo freeMemory  si potrebbe evitare il native mem
  //        mem= Runtime.getRuntime().freeMemory();


  // Vengono fatti partire o fermare i processi nativi che servono
  // per rilevare lo stato.
  private void init(){}//ADD CODE HERE
  private void stop(){}//ADD CODE HERE
  /////

  //Metodi publici accessibili da MonitorService
  public float	getCpu(){return getCpuNative();}
  public long 	getMem(){return getMemNative();}
  public Response getState(){
            Response res = new Response();
            res.cpu=getCpuNative();
            res.memFree=getMemNative();
            res.memTot= this.memTot;
            res.memUsed= this.memUsed;
            res.date= new Date();
            try{
            res.nomeHost= InetAddress.getLocalHost().getHostName();
            }catch(java.net.UnknownHostException e)
            {
              res.nomeHost= "LocalHost";
            }
            return res;
            }


  //Restituisce nome dell'host, utilizzo mem e cpu.
  public String toString(){ getMem();
  	return "Utilizzo Cpu: "+getCpu()+" Utilizzo Memoria libera: "+ memFree+"/"+memTot+" percentuale usata: "+ (float)memUsed/(float)memTot ;
	}
  /////

  ///Il MAIN serve solo per delle prove
   public static void main(String[] args) {
      System.out.println(new GestoreNative());
   }
}

