/*
MonitorService.java

  Questa classe preleva le informazione da tutti i serverRmi registrati
  all'rmiRegistry e stampa i risultati

  to run:
    java CaricoMacchina.MonitorService serverRmi


25/02/2000

Il thread ora seleziona tutti i serverRMI registrati con nome:
      rmi://nomeHostRmiregistry/Stato/qualunqueServerRmi
e li stampa a video

27/02/2000

  MonitorService  una servlet che comunica con l'applet attraverso un
  ObjectOutputStream e un ObjectImputStream

18/03/2000
Gabriele Tinti
*/


package CaricoMacchina;

import javax.servlet.*;
import javax.servlet.http.*;
import java.rmi.*;
import java.net.*;
import java.lang.reflect.*;
import java.io.*;
import java.util.Vector;



public class MonitorService extends HttpServlet{

  private String host=null; // host del serverRMI
                            // di default  inviato dall'applet
  private String  serverList[] =null;

  private static Vector serverRmiList =new Vector();

  //Stream per comunicare con l'applet
  private ObjectInputStream   in  =null;
  private ObjectOutputStream  out =null;
  private OptionRequest       opt =null;  //opzioni inviate dall'applet

  static int nroServlet=0;

  static boolean standAlone = false; // Server per capire in fase di test
                              // se la servlet  standAlone


  public MonitorService() {

  }

  // Preleva lo stato delle macchine e costruisce una report
  // come risultato
  public void service(String host)
    {
      opt= new OptionRequest(); //Serve per test StandAlone
      this.host=host;
      service();
    }

  public void service()
  {
     if(!standAlone)host= opt.jHostRMI;
  //Creazione SecurityManager
     if (System.getSecurityManager() == null) {
          System.setSecurityManager(new RMISecurityManager());
       }
  /////


  //E' una richiesta di registrazione
        if(opt.typeRequest==0)
        {
          System.out.println("GestoreJava: Richiesta Registrazione di "+ opt.jHostRMI);
          synchronized(this.serverRmiList)
          {
              this.serverRmiList.add(opt.jHostRMI);
          }
          try{
          out.writeObject(new String("ok"));
          out.flush();
          }catch(IOException ex)
              {System.out.println("GestoreJava: Problemi in writeObject");}
          return;
        }

  // Acquisizione di tutti i reference registrati all'rmiregistry
        if(this.serverRmiList.isEmpty())return;
        String hostRmiregistry="";  // host e servizio ricercato nell'rmiregistry

        for(int j=0; j< this.serverRmiList.size(); j++)
        {

        try {
            System.out.println("Richiesta lista serveRMI al rmiregistry");

            hostRmiregistry="rmi://"+serverRmiList.elementAt(j)+"/Stato";
            // richiesto dalle impostazioni
            if(!opt.isRequest(hostRmiregistry)) continue;

            serverList = Naming.list(hostRmiregistry);
            System.out.println("numero ServerRmi registrati: "+Array.getLength(serverList));
            System.out.println("Lista completata");
        } catch (Exception e) {
            System.err.println("MonitorService: pb nell'acquisizione dei reference: \n" + e.toString());
            System.err.println("MonitorService: il server rmi "+serverRmiList.elementAt(j)+" non risponde");
            System.err.println("MonitorService: verr cancellato dalla lista");
            serverRmiList.remove(j);j--;
            continue;
        }

  /////

      // Ciclo per contattare tutti e soli i serverRmi registrati
      // per il servizio Stato
        for(int i=0;i<Array.getLength(serverList);i++)
        {
        // se true significa non  il servizio Stato e quindi salta
        // al ciclo for successivo
        if(!(serverList[i].startsWith(hostRmiregistry)))continue;
        /////

            // RICHIEDO il reference del ServerRMI chiamato serverList[i]
            GestoreJavaRem macchina=null;
            try{
            macchina = (GestoreJavaRem) Naming.lookup(serverList[i]);
            System.out.println("Ho un reference da remoto: "+serverList[i]);
            }catch(Exception ex){
                    System.err.println("Monitor Service: Problemi acquisizione reference");

                    try{
                    Naming.unbind(serverList[i]);
                    }catch(Exception ex1){System.out.println("Problemi a cantattare RMiregistry");}
                    continue;
                }// gestione abbandono gestoreJava


            //Si richiede l'esecuzione dei metodi per prelevare lo stato
            //Aggiungere metodi di costruzione tabella o html pag
           try {
            //Invio sull'ouputStream
               Response res = macchina.getState();

               //Spedisco l'oggetto all'applet
               sendToApplet(res);
               //Stampo a console i dati ricavati
               //TEST
               System.out.println("-+-+-+-+-+-+-+-+-+-+");
               System.out.println("Stato : "+res.toString());

         //Gestione errori
        } catch (Exception e) {
            System.err.println("MonitorService exception: \n" + e.getMessage());
            System.out.println("Abbandono di "+serverList[i]);
                    try{
                    Naming.unbind(serverList[i]);
                    }catch(Exception ex1){System.out.println("Problemi a cantattare RMiregistry");}
                    continue;
        }
        }/////// end ciclo prelevamento reference

        }// end for per interrogare tutti i gli RmiRegistry
  }//end service


//JGT---------------------------------------------------------------------------
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    // invocando l'url direttamente dal browser si pu
    // verificare che la servlet sia raggiungibile
    System.out.println("Servlet: CaricoMacchina.MonitorService. Start Metodo Get ");
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();
    System.out.println("Servlet: smqServer.AplServlet. Metodo run di get ");
    out.println("<HTML><BODY>");
    out.println("Servlet MonitorService Attiva");
    out.println("</BODY></HTML>");
    out.close();
    System.out.println("Servlet: CaricoMacchina.MonitorService. End Metodo Get ");
  }

//JGT---------------------------------------------------------------------------
	public void doPost(HttpServletRequest request, HttpServletResponse response)
              throws ServletException, IOException {

    //Creare uno ObjectStream  di oggetti da inviare all'applet
    try
      {
        System.out.println("Servlet: CaricoMacchina.MonitorService. Start Metodo Post ");
        in  = new ObjectInputStream (request.getInputStream());
        out = new ObjectOutputStream(response.getOutputStream());

        // Leggo una richiesta di autenticazione  JINT_Q_Authentication dall'applet
        opt=(OptionRequest)in.readObject();
        // invoco il servizio che invia all'applet i risultati della ricerca
        service();
      }
    catch (Exception exc){
    	    System.out.println(exc.toString());}

     //chiusura flussi
      out.flush();
      out.close();
      in.close();
    System.out.println("Servlet: End Metodo Post");
	}

  private void sendToApplet(Object res)  throws java.io.IOException
  {
    if(out!=null)out.writeObject(res);
    else System.out.println("MonitorService non e' in grado di comunicare con l'applet");
  }
//JGT---------------------------------------------------------------------------

  public static void main(String args[]) {


        if((args.length==2)&&(args[0].equals("-h"))){
            new MonitorService().service(args[1]);}
        else
          { System.out.println("Errore argomenti: digitare java CaricoMacchina.MonitorService -h nomeHostRmi");
            System.exit(1);   }

        System.out.println("Fine servizio");
        standAlone=true;
    }

}//end MonitorService
