/*
	CaricoMacchina_GestoreNative.c
	
	Implementa in C i metodi nativi necessari al
	Tesina Reti di calcolatori

	getMemState 
	setta le variabili Java di 
		memTot, memUsed , memFree
.	occorre aggiungerle in GestoreNative.java
	
.	occorre inserire il codice di esegui.c in questo file e verificare che funzioni

16/03/2000

Gabriele Tinti
*/

#include "CaricoMacchina_GestoreNative.h"
#include <stdio.h>


 float getCpuState();
 long  getMemState(long *,long *,long *);

JNIEXPORT jfloat JNICALL Java_CaricoMacchina_GestoreNative_getCpuNative
	(JNIEnv *env, jobject thisObj)
{
   //Contiene il valore delo stato della cpu prelevato dalla funzione C getCpuState()
 	jfloat valCpu=0;	

   //Invoca il metodo getCpuState per prelevare lo stato della cpu
	valCpu = (jfloat)getCpuState();  

   //Setta il valore della variabile GestoreNative.cpu 
	jclass clazz = env->GetObjectClass(thisObj);
	jfieldID fid = env->GetFieldID(clazz, "cpu","F");
	env->SetFloatField(thisObj,fid, valCpu);

	return valCpu;
}


JNIEXPORT jlong JNICALL Java_CaricoMacchina_GestoreNative_getMemNative
	(JNIEnv *env, jobject thisObj)
{
   //Contiene il valore delo stato della mem prelevato dalla funzione C getCpuState()
 	long valMemTot=0,valMemUsed=0,valMemFree=0;	

   //Invoca il metodo getCpuState per prelevare lo statto della cpu
	valMemFree = getMemState(&valMemTot,&valMemUsed,&valMemFree);  

	
   //Setta il valore della variabile GestoreNative.cpu 
	jclass clazz = env->GetObjectClass(thisObj);
	jfieldID fid = env->GetFieldID(clazz, "memTot","J"); //J -> jlong
	env->SetLongField(thisObj,fid, (jlong)valMemTot);

	fid = env->GetFieldID(clazz, "memUsed","J"); //J -> jlong
	env->SetLongField(thisObj,fid, (jlong)valMemUsed);

	fid = env->GetFieldID(clazz, "memFree","J"); //J -> jlong
	env->SetLongField(thisObj,fid, (jlong)valMemFree);

	return valMemFree;
}

