/*

	nativeCpuMem.cpp

  in questo file sono contenute le routine per trovare lo stato della cpu e 
  della memoria

  Gestione Memoria attraverso l'invocazione di 
	GlobalMemoryStatus(p) 
	ottengo un ptr p che punta a una struttura di tipo MEMORYSTATUS

typedef struct _MEMORYSTATUS { // mst 
    DWORD dwLength;        // sizeof(MEMORYSTATUS) 
    DWORD dwMemoryLoad;    // percent of memory in use 
    DWORD dwTotalPhys;     // bytes of physical memory 
    DWORD dwAvailPhys;     // free physical memory bytes 
    DWORD dwTotalPageFile; // bytes of paging file 
    DWORD dwAvailPageFile; // free bytes of paging file 
    DWORD dwTotalVirtual;  // user bytes of address space 
    DWORD dwAvailVirtual;  // free user bytes 
} MEMORYSTATUS, *LPMEMORYSTATUS

PROBLEMI NEL TROVARE L'HEADER DI DWORD I METODI USATI SONO DI MFC
  
27/02/2000

	Inserisco lo scheletro di una applicazione mfc per testare le procedure 
	che miservono

29/02/2000
Gabriele tinti
*/


#include <stdio.h>
//#include <winbase.h>

#include <windows.h>
#include <winreg.h>


 float getCpuState();
 long  getMemState(long *,long *,long *);

 long  getMemState(long *memTot,long *memUsed,long *memFree)
 {
	////	routine per la trovare lo stato della memoria		
	// In MEMORYSTATUS ho tutte le informazioni sulla mem
	LPMEMORYSTATUS p;	
	p= (LPMEMORYSTATUS  )malloc(sizeof (struct _MEMORYSTATUS));
	p->dwLength= sizeof(MEMORYSTATUS);	
	GlobalMemoryStatus(p);
	p->dwAvailPhys;	
	///
	*memTot		= p->dwTotalPhys;
	*memFree	= p->dwAvailPhys;
	*memUsed	= ((long)p->dwTotalPhys-(long)p->dwAvailPhys);
    return p->dwAvailPhys;
 }


 //Abilita il counter 

BOOL EnableDataCollection(char *szObjName, char *szCounterName)
   {

    HKEY hOpen;
    DWORD cbData;
    DWORD dwType;
    LPBYTE pByte;
    DWORD rc;
    char *szCounterData;
    BOOL bSuccess = TRUE;

    if ( (rc = RegOpenKeyEx(HKEY_DYN_DATA,"PerfStats\\StartStat", 0,
                           KEY_READ, &hOpen)) == ERROR_SUCCESS)
    {
      // concatenate the object and couter key names
      szCounterData = (char *)LocalAlloc(LPTR,lstrlen(szObjName) + lstrlen(szCounterName) + 2);
      wsprintf(szCounterData, "%s\\%s", szObjName, szCounterName);

      // query to get data size
      if ( (rc = RegQueryValueEx(hOpen,szCounterData,NULL,&dwType,NULL, &cbData )) == ERROR_SUCCESS )
      {
         pByte =(unsigned char *) LocalAlloc(LPTR, cbData);

         // query the performance start key to initialize performance data
         // query the start key to initialize performance data
         rc = RegQueryValueEx(hOpen,szCounterData,NULL,&dwType, pByte,
                              &cbData );
         // at this point we don't do anything with the data
         //  free up resources
         LocalFree(pByte);
      }
      else
         bSuccess = FALSE;

      RegCloseKey(hOpen);
      LocalFree(szCounterData);
    }
    else
      bSuccess = FALSE;

    return bSuccess;

   } 

//Preleva dati

BOOL CollectPerfData(char *szObjName, char *szCounterName,

                        DWORD *pdwData)

   {

    HKEY hOpen;
    DWORD dwType;
    DWORD cbData;
    char *szCounterData;
    DWORD rc;
    BOOL bSuccess = TRUE;

    // concatenate the object and counter keys
    szCounterData = (char *)LocalAlloc(LPTR,lstrlen(szObjName) + lstrlen(szCounterName) + 2);
    wsprintf(szCounterData, "%s\\%s", szObjName, szCounterName);

    // open performance data key
    if ( (rc = RegOpenKeyEx(HKEY_DYN_DATA,"PerfStats\\StatData", 0,
         KEY_READ, &hOpen)) == ERROR_SUCCESS)
    {
      cbData = sizeof(DWORD);
      // retrieve performance data which is of size of DWORD
      rc=RegQueryValueEx(hOpen,szCounterData,0,&dwType,
            (LPBYTE)pdwData,&cbData );

      // let the caller know if it worked or not
      bSuccess = rc == ERROR_SUCCESS;
      RegCloseKey(hOpen);
    }
    else
      bSuccess = FALSE;

    // free the resources
    LocalFree(szCounterData);
    return bSuccess;
   } 	


 float getCpuState()
 {
	 int ris;
	 DWORD cpu;

	 cpu=1000;
	 // abilita il contatore dell'utilizzo della CPU
	 ris= (int)EnableDataCollection("KERNEL","CPUUsage");
	 // preleva il dato dell'uso della cpu
	 ris=(int)CollectPerfData("KERNEL","CPUUsage",&cpu);
	
	 return (float)cpu;

 }



main()
{	
	long memTot;long memFree;long memUsed;
	getMemState(&memTot,&memUsed,&memFree);

	printf("Start sessione di prova\n");
	
	printf("LO STATO DELLA MEMORIA DISPONIBILE e' %ld/%ld\n", memFree,memTot);	
	printf("Percentuale memoria disponibile %1.2f\n",(float)memUsed/(float)memTot);
	while(true)
	{
		getchar();

	printf("Percentuale uso processore %1.2f\n",getCpuState());
	}	
	return 0;

}


